//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Model } from 'mongoose';
import { Task, TaskDocument } from '../Task';
import { TaskService } from '../TaskService';
import { BaseController } from '@core/api/BaseController';
import { MEDICALPRACTICE_PERMISSIONS } from '@modules/medicalpractice/permissions';
import { Get, Post, Patch, Delete, QueryParams, UseBefore, Res, Body, Param, Session, Header } from 'routing-controllers';
import { authenticated, checkPermission, checkApiDisabled, checkResourceDisabled } from '@core/api/middleware';
import { ModelController } from '@core/api/decorators';

@ModelController('Task')
@UseBefore(checkApiDisabled(TaskBaseController))
export class TaskBaseController extends BaseController {
    protected model: Model<TaskDocument>;

    protected static readonly _objName: string = 'Task';
    protected static readonly _apiDisabled: boolean = true;
    protected static readonly _readable: boolean = true;
    protected static readonly _creatable: boolean = true;
    protected static readonly _updatable: boolean = true;
    protected static readonly _deletable: boolean = true;
    protected static readonly _permission = {
        read: MEDICALPRACTICE_PERMISSIONS.TASK.READ,
        create: MEDICALPRACTICE_PERMISSIONS.TASK.CREATE,
        update: MEDICALPRACTICE_PERMISSIONS.TASK.UPDATE,
        delete: MEDICALPRACTICE_PERMISSIONS.TASK.DELETE,
    };
    protected static readonly _auth = {
        read: true,
        create: true,
        update: true,
        delete: true,
    };

    constructor(taskService: TaskService) {
        super(Task, taskService);
    }

    @Get('/')
    @UseBefore(checkResourceDisabled(TaskBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async getAllTask(@QueryParams() params) {
        return super.getAll(params);
    }

    @Get('/:id')
    @UseBefore(checkResourceDisabled(TaskBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async getOneTask(@Param('id') id: string, @QueryParams() params) {
        return await super.getOne(id, params);
    }

    @Post('/')
    @UseBefore(checkResourceDisabled(TaskBaseController.creatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async postTask(@Session() session, @Body() body: any) {
        return super.post(body, session);
    }

    @Patch('/:id')
    @UseBefore(checkResourceDisabled(TaskBaseController.updatable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async patchTask(@Session() session, @Param('id') id: string, @QueryParams() params, @Body() body: any) {
        return super.patch(id, body, session, params);
    }

    @Delete('/:id')
    @UseBefore(checkResourceDisabled(TaskBaseController.deletable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async deleteTask(@Session() session, @Param('id') id: string) {
        return super.delete(session, id);
    }

    @Get('/meta/options')
    @UseBefore(authenticated)
    public async getMetaOptionsTask(@QueryParams() query) {
        return await super.getMetaOptions(query);
    }

    @Get('/export/csv')
    @Header('Content-Type', 'text/csv')
    @UseBefore(checkResourceDisabled(TaskBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async getCsvExportTask(@Res() response, @QueryParams() query) {
        response.attachment(`${TaskBaseController._objName.toLowerCase()}.csv`);
        const data = await super.getExport('csv', query);
        return response.send(data);
    }

    @Get('/export/xlsx')
    @Header('Content-Type', 'application/vnd.ms-excel')
    @UseBefore(checkResourceDisabled(TaskBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async getXlsxExportTask(@Res() response, @QueryParams() query) {
        response.attachment(`${TaskBaseController._objName.toLowerCase()}.xlsx`);
        const data = await super.getExport('xlsx', query);
        return response.send(data);
    }

    @Get('/export/pdf')
    @Header('Content-Type', 'application/pdf')
    @UseBefore(checkResourceDisabled(TaskBaseController.readable))
    @UseBefore(checkPermission(MEDICALPRACTICE_PERMISSIONS.TASK.READ))
    @UseBefore(authenticated)
    public async getPdfExportTask(@Res() response, @QueryParams() query) {
        response.attachment(`${TaskBaseController._objName.toLowerCase()}.pdf`);
        const data = await super.getExport('pdf', query);
        return response.send(data);
    }
}
